'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

exports.default = fetch;

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _hooks;

function _load_hooks() {
  return _hooks = _interopRequireDefault(require('../../../hooks'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var HooksManagerInstance = (_hooks || _load_hooks()).default.getInstance();

function fetch(path, ids) {
  var _this = this;

  var noDependencies = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var headers = arguments[3];

  var bitIds = (_bitId || _load_bitId()).BitIds.deserialize(ids);
  var args = { path, bitIds, noDependencies };
  HooksManagerInstance.triggerHook((_constants || _load_constants()).PRE_SEND_OBJECTS, args, headers);
  return (0, (_scope || _load_scope()).loadScope)(path).then(function (scope) {
    if (noDependencies) return scope.manyOneObjects(bitIds);
    return scope.getObjects(bitIds).then(function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(componentObjects) {
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return HooksManagerInstance.triggerHook((_constants || _load_constants()).POST_SEND_OBJECTS, {
                  componentObjects,
                  scopePath: path,
                  componentsIds: bitIds.serialize(),
                  scopeName: scope.scopeJson.name
                }, headers);

              case 2:
                return _context.abrupt('return', componentObjects);

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }));

      return function (_x2) {
        return _ref.apply(this, arguments);
      };
    }());
  });
}